/***************************************************************************

                          pongpaddle.cpp
                          paddle for bluePong - implemented as a
                          special kind of wall - IMPLEMENTATION
                             -------------------
    begin                : Die Mai 27 2003
    copyright            : (C) 2003 by Thomas Unterthiner
    email                : thomas_unterthiner@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pongpaddle.h"

PongPaddle::PongPaddle(int PosX, int PosY, int Width, int Height,
	                    Uint32 Color, Alignment Align,
	                    Uint32 BackgroundColor)
/*****************************************************************************
 * the normal Ctor
 *****************************************************************************/
           : PongWall (PosX, PosY, Width, Height, Color, Align, BackgroundColor)
{
	
}

void PongPaddle::move( int By)
/*****************************************************************************
 * moves the paddle in the only possible direction (defined by the alignment
 * of the paddle)
 * 	PARAMETER
 * 		int ByX = move by that many px (1 by default)
 *****************************************************************************/
{
	if ( this->getAlignment() == ALIGN_HORIZONTAL)
	{
		ColorSprite::move(By, 0);
	}
	else
	{
		ColorSprite::move(0, By);
	}
}
