/***************************************************************************

                          pongplayer.h 
                          a very simple player-class for bluePong
                             -------------------
    begin                : Die Mai 27 2003
    copyright            : (C) 2003 by Thomas Unterthiner
    email                : thomas_unterthiner@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PONGPLAYER_H
#define PONGPLAYER_H

#include <SDL.h>
#include <cstring>
#include "pongpaddle.h"
#include "sdl_functions.h"
#include <vector>

#include <iostream>

enum PlayerSide {RIGHT_SIDE, LEFT_SIDE, TOP_SIDE, BOTTOM_SIDE};

class PongPlayer
{
public: 
	PongPlayer(Uint32 Color, char* Name,
	           SDLKey* Keys,
	           unsigned short KeyCount,
	           PongPaddle& Paddle,
	           PlayerSide Side);
	// ctor

	~PongPlayer();
	// dtor

	int addPoint(int Amount = 1); 
	// adds points (1 point per default)
	// 	RETURNS
	// 		remaining points AFTER adding the points

	// ---------------------------------------
	// access-functions to the private members
	// ---------------------------------------
	int         getPoints()       const {return mPoints;}
	Uint32      getColor()        const {return mColor;}
	const char* getName()         const {return mName;}
	SDLKey      getKey(short Nr)  const {return mKeys[Nr];}
	PongPaddle& getPaddle()       const {return mPaddle;}
	PlayerSide  getSide()         const {return mSide;}

private:
	int mPoints;
	Uint32 mColor;
	char* mName;
	SDLKey* mKeys;
	unsigned short mKeyCount;
	PongPaddle& mPaddle;
	PlayerSide mSide;
};

#endif
