/***************************************************************************

                          pongwall.h 
                          a wall - a special sprite - in a game of
                          bluePong
                             -------------------
    begin                : Mon Mai 26 2003
    copyright            : (C) 2003 by Thomas Unterthiner
    email                : thomas_unterthiner@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PONGWALL_H
#define PONGWALL_H

#include "colorsprite.h"

enum Alignment {ALIGN_HORIZONTAL = 1, ALIGN_VERTICAL};

class PongWall : public ColorSprite
{
public:
	PongWall(int PosX, int PosY, int Width, int Height,
	         Uint32 Color, Alignment Align,
	         Uint32 BackgroundColor = 0);
	// default ctor

	virtual ~PongWall() {};
	// dtor, doesn't do anything

	virtual bool isCollidingWith(const ColorSprite& b) const;
	// checks if this object collides with another ColorSprite
	// 	PARAMETER
	// 		const ColorSprite& b: the other sprite
	// 	RETURNS
	// 		TRUE on collision, FALSE in any other case
	

	Alignment getAlignment() const {return mAlignment;}

private:
	Alignment mAlignment;
};

#endif
