/***************************************************************************
		blueDoublePong 0.1
  		(C) 2003 by Thomas Unterthiner
		-------------------

	sdl_functions.cpp
	some usefull SDL-functions

	begin   : Son Mai 18 2003
	version : 1.0
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sdl_functions.h"


SDL_Surface* SDL_Initiate()
/****************************************************************************
 * basic SDL-initiation work:
 * creates a top-window, colored blue.
 *	RETURN
 *		pointer to the created window
 *****************************************************************************/
{
	if (SDL_Init( SDL_INIT_VIDEO ) == -1)
	{
		printf( "Can't init SDL: %s\n", SDL_GetError() );
		exit(1);
	}
 	atexit(SDL_Quit);

	SDL_Surface* screen = SDL_SetVideoMode(800, 600, 16, SDL_SWSURFACE 
	                                                     | SDL_DOUBLEBUF
	                                                     | SDL_ANYFORMAT);
	if (screen == 0)
	{
		printf( "Can't set video mode: %s\n", SDL_GetError() );
		exit(1);
	}
//	SDL_FillRect( screen, NULL, SDL_MapRGB(screen->format, 0, 0, 0) ); // black screen
	return screen;
}




SDL_Surface* loadImage(const char* filepath)
/****************************************************************************
 * loads an image (BMP) and converts it to the Displayformat
 *	RETURN
 *		pointer to the loaded bitmap
 *****************************************************************************/
{
	// load image and blit it onto the screen
	SDL_Surface* tmp = SDL_LoadBMP(filepath);
	if (tmp == 0)
	{
		printf("Can't load the image: %s\n", SDL_GetError() );
		exit(1);
	}
	SDL_Surface* image = SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	return image;
}



void writeDebugLog(const char* Message)
/****************************************************************************
 * writes some debug-output
 *****************************************************************************/
{
	#ifdef DEBUG
	printf("%s", Message);
	printf("%s\n", SDL_GetError() );
	#endif
}



void writeLowDebugLog(const char* Message)
/****************************************************************************
 * writes some debug-output
 *****************************************************************************/
{
	#ifdef DEBUG
	writeDebugLog(Message);
	#endif
}



Uint32 waitForNextFrame()
{
    static Uint32 nextTime = 0;
    Uint32 now;

    now = SDL_GetTicks();
    if ( nextTime <= now )
    {
        nextTime = now+INTERVAL_MS;
        return 0;
    }
    return nextTime - now;
}
